Subject: Re: [RFC VLAN 00/10]: VLAN netlink support try 2

From: Patrick McHardy <[email-masked]>
Date: Tue, 05 Jun 2007 23:12:23 +0200

Ben Greear wrote:
> Patrick McHardy wrote:
> 
>> Ben Greear wrote:
>>
>>> Patrick McHardy wrote:
>>>
>>>> The last VLAN patchset was outdated, sorry about the mixup. These
>>>> are the
>>>> correct patches. The iproute patch I posted was correct, so no
>>>> repost of
>>>> that one.
>>>>
>>>>   
>>>
>>> Is there any significant performance penalty in creating VLANs using
>>> these patches?
>>>
>>> If you have a test station handy, could you let us know what 'time'
>>> shows for a script
>>> creating 4000 VLANs with the old vconfig/ioctl method v/s this new
>>> method?
>>
>>
>>
>> Not significantly more, for 1000 VLANs I get:
>>
>> ip link add:
>>
>> real    0m22.836s
>> user    0m0.100s
>> sys     0m5.850s
>>
>> vconfig add:
>>
>> real    0m19.739s
>> user    0m0.090s
>> sys     0m3.600s
> 
> 
> Thanks for doing the tests.  That small performance drop seems
> fine to me.

I'll try to speed it up a bit more, my initial version needed something
like 10s for 1000 VLANs. I suspect the iproute RTM_NEWLINK probing done
for every (non-batched) operation adds quite significantly to the
overhead.